<script>
import {toNumber} from "lodash";

export default {
  props: {
    topUsers: {
      type: Array,
    },
    currentUserId: {
      type: Number,
    }
  },

  setup(props) {
    const isMe = (id) => id == props.currentUserId;
    const prepareUserTop = (index) => {
      const top = toNumber(index) + 1;

      return `ТОП-${top} `;
    };
    const prepareUserLessonsCount = (count) => ` (пройдено тем: ${count})`;

    return {
      isMe,
      prepareUserTop,
      prepareUserLessonsCount,
    };
  }
}
</script>

<template>
  <section>
    <header>
      <h2 class="text-lg font-medium text-gray-900">Рейтинговая таблица</h2>
    </header>
  </section>
  <div class="grid-area-2">
    <section class="friend-acitvity">
      <div class="friend-activity__activity">
        <h3 v-for="(user, index) in topUsers" class="friend-activity__row">
          <span class="friend-activity__rating">{{ prepareUserTop(index) }}</span>
          <span class="friend-activity__name">{{ user.name }}</span>
          <span class="friend-activity__msg">{{ prepareUserLessonsCount(user.lessons_count) }}</span>
          <span v-if="isMe(user.id)" class=""> это ты</span>
        </h3>
      </div>
    </section>
  </div>
</template>

<style scoped lang="css">
.grid-area-2 {
  grid-column: 2 / 3;
  grid-row: 1 / 3;

  display: flex;
  flex-direction: column;
  gap: 4rem;
}

.friend-acitvity {
  display: flex;
  flex-direction: column;
}
.friend-activity__activity {
  grid-template-columns: 4rem 1fr;
  gap: 2rem;
  align-items: center;
}

.friend-activity__row {
  color: red;
  font-size: 1.2rem;
  font-weight: 400;
}
.friend-activity__name {
  font-size: 1.5rem;
  color: blue;
}
.friend-activity__rating {
  font-size: 1.5rem;
}
.friend-activity__msg {
  color: black;
  font-size: 1.0rem;
}

</style>
